<?php
  $i18n = &$params; // alias for i18n parsing
  $slug = array_key_exists('slug',$params) ? $params['slug'] : return_page_slug();
  $showTags = array_key_exists('showTags',$params) ? $params['showTags'] : true;
  $minTagSizePercent = array_key_exists('minTagSize',$params) ? (int) $params['minTagSize'] : 100;
  $maxTagSizePercent = array_key_exists('maxTagSize',$params) ? (int) $params['maxTagSize'] : 250;
  $goText = @$i18n['GO'];
?>
<form action="<?php echo find_url($slug, null); ?>" method="POST">
<?php if ($showTags && $minTagSizePercent && $maxTagSizePercent && $minTagSizePercent > 0 && $minTagSizePercent <= $maxTagSizePercent) { ?>
  <div class="tags"><?php get_i18n_tags_impl($minTagSizePercent,$maxTagSizePercent); ?></div>
  <input type="hidden" name="tags" value="<?php echo htmlspecialchars(@$_REQUEST['tags']); ?>"/>
  <script type="text/javascript">
    $(function() {
      $('.tags .tag').click(function(e) {
        $(e.target).toggleClass('selected');
        var tags = ''
        $('.tags .tag.selected').each(function() { tags += ' '+$(this).text(); });
        $('[name=tags]').val(tags);
      });
      var tags = $('[name=tags]').val().split(' ');
      $('.tags .tag').each(function() { if ($.inArray($(this).text(),tags) >= 0) $(this).addClass('selected'); });
    })
  </script>
<?php } ?>
  <input type="text" name="words" value="<?php echo htmlspecialchars(@$_REQUEST['words']); ?>"/>
  <input type="submit" name="search" value="<?php echo @$goText; ?>" />
</form>

